﻿using System;
using System.Collections.Generic;

namespace School
{
    public class Teacher : IComparable<Teacher>
    {
        private static readonly IComparer<Teacher> NameComp = new TeacherNameComparer();
        public static IComparer<Teacher> NameComparer { get { return NameComp; } }

        private static readonly IComparer<Teacher> NameSalaryComp = new TeacherNameSalaryComparer();

        public static IComparer<Teacher> NameSalaryComparer { get { return NameSalaryComp; } }

        public int Id { get; set; }
        public String Name { get; set; }
        public int Salary { get; set; }

        public override string ToString()
        {
            return string.Format("Id:{0}, Name:{1}, Salary:{2}", Id, Name, Salary);
        }

        public int CompareTo(Teacher other)
        {
            return this.Id - other.Id;
        }
    }
}
