﻿using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using School;

namespace SortingSearchingObjectsTests1
{
    [TestClass]
    public class TeacherTests
    {
        private readonly Teacher _t1 = new Teacher { Id = 1, Name = "Anders", Salary = 100 };
        private readonly Teacher _t2 = new Teacher { Id = 3, Name = "Anders", Salary = 200 };
        private readonly Teacher _t3 = new Teacher { Id = 34, Name = "John", Salary = 23 };

        [TestMethod]
        public void CompareToTest()
        {
            Assert.IsTrue(_t1.CompareTo(_t2) < 0);
            Assert.IsTrue(_t1.CompareTo(_t3) < 0);
        }

        [TestMethod]
        public void NameComparerTest()
        {
            Assert.IsTrue(Teacher.NameComparer.Compare(_t1, _t2) == 0);
            Assert.IsTrue(Teacher.NameComparer.Compare(_t1, _t3) < 0);
        }

        [TestMethod]
        public void SalaryComparerTest()
        {
            Assert.IsTrue(Teacher.NameSalaryComparer.Compare(_t1, _t2) < 0);
            Assert.IsTrue(Teacher.NameSalaryComparer.Compare(_t1, _t3) < 0);
        }

        [TestMethod]
        public void ReverseComparerTest()
        {
            IComparer<Teacher> reverseNameComparer = new ReverseComparer<Teacher>(Teacher.NameComparer);
            Assert.IsTrue(reverseNameComparer.Compare(_t1, _t2) == 0);
            Assert.IsTrue(reverseNameComparer.Compare(_t1, _t3) > 0);
        }
    }
}
